#include <qglobal.h>
#include <qvariant.h>
#include <qptrvector.h>
#include <qvaluevector.h>
#include <qsqlresult.h>

class QtSqlCachedResultPrivate;

class QM_EXPORT_SQL QtSqlCachedResult: public QSqlResult
{
public:
    virtual ~QtSqlCachedResult();

    typedef QValueVector<QVariant> RowCache;
    typedef QPtrVector<RowCache> RowsetCache;

protected:    
    QtSqlCachedResult(const QSqlDriver * db);

    void init(int colCount);
    void cleanup();
    bool cacheNext();

    virtual bool gotoNext(RowCache* row) = 0;

    QVariant data(int i);
    bool isNull(int i);
    bool fetch(int i);
    bool fetchNext();
    bool fetchPrev();
    bool fetchFirst();
    bool fetchLast();

    int colCount() const;

private:
    QtSqlCachedResultPrivate *d;
};
